%global scl devtoolset-1.1
%{?scl:%scl_package}
Summary: Package that installs %scl
Name: %scl_name
Version: 1
Release: 13%{?dist}
BuildArch: noarch
License: GPLv2+
Group: Applications/File
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: %{scl_prefix}gcc %{scl_prefix}gcc-c++ %{scl_prefix}gcc-gfortran
Requires: %{scl_prefix}binutils %{scl_prefix}gdb
Requires: %{scl_prefix}dwz %{scl_prefix}elfutils %{scl_prefix}valgrind
Requires: %{scl_prefix}oprofile %{scl_prefix}systemtap
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

# We need to provide the Obsoletes here as well in order to 'yum update'
# work correctly.
Obsoletes: devtoolset-1.0, devtoolset-1.0-runtime, devtoolset-1.0-build
Obsoletes: devtoolset-1.0-binutils, devtoolset-1.0-binutils-devel
Obsoletes: devtoolset-1.0-gdb, devtoolset-1.0-gdb-gdbserver, devtoolset-1.0-gdb-doc
Obsoletes: devtoolset-1.0-gcc, devtoolset-1.0-gcc-c++, devtoolset-1.0-gcc-plugin-devel
Obsoletes: devtoolset-1.0-libitm-devel, devtoolset-1.0-libquadmath-devel
Obsoletes: devtoolset-1.0-libstdc++-devel, devtoolset-1.0-libstdc++-docs

%description
This is the main package for %scl Software Collection.

%package runtime
Summary: Package that handles %scl Software Collection.
Group: Applications/File
Requires: scl-utils
# Having DTS 1.0 and DTS 1.1 installed at the same time is unsupported.
Obsoletes: devtoolset-1.0, devtoolset-1.0-runtime, devtoolset-1.0-build
Obsoletes: devtoolset-1.0-binutils, devtoolset-1.0-binutils-devel
Obsoletes: devtoolset-1.0-gdb, devtoolset-1.0-gdb-gdbserver, devtoolset-1.0-gdb-doc
Obsoletes: devtoolset-1.0-gcc, devtoolset-1.0-gcc-c++, devtoolset-1.0-gcc-plugin-devel
Obsoletes: devtoolset-1.0-libitm-devel, devtoolset-1.0-libquadmath-devel
Obsoletes: devtoolset-1.0-libstdc++-devel, devtoolset-1.0-libstdc++-docs

%description runtime
Package shipping essential scripts to work with %scl Software Collection.

%package build
Summary: Package shipping basic build configuration
Group: Applications/File

%description build
Package shipping essential configuration macros to build %scl Software Collection.

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_scl_scripts}/root
cat > %{buildroot}/%{_scl_scripts}/enable <<\EOF
export PATH=%{_bindir}${PATH:+:${PATH}}
export MANPATH=%{_mandir}:$MANPATH
export INFOPATH=%{_infodir}${INFOPATH:+:${INFOPATH}}
export PCP_DIR=%{_scl_root}
# Some perl Ext::MakeMaker versions install things under /usr/lib/perl5
# even though the system otherwise would go to /usr/lib64/perl5.
export PERL5LIB=%{_scl_root}/%{perl_vendorarch}:%{_scl_root}/usr/lib/perl5:%{_scl_root}/%{perl_vendorlib}${PERL5LIB:+:${PERL5LIB}}
# bz847911 workaround:
# we need to evaluate rpm's installed run-time % { _libdir }, not rpmbuild time
# or else /etc/ld.so.conf.d files?
rpmlibdir=`rpm --eval "%%{_libdir}"`
export LD_LIBRARY_PATH=%{_scl_root}$rpmlibdir${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
# duplicate python site.py logic for sitepackages
pythonvers=`python -c 'import sys; print sys.version[:3]'`
export PYTHONPATH=%{_prefix}/lib64/python$pythonvers/site-packages:%{_prefix}/lib/python$pythonvers/site-packages${PYTHONPATH:+:${PYTHONPATH}}
EOF
mkdir -p %{buildroot}/%{_scl_root}/usr/bin
cat > %{buildroot}/%{_scl_root}/usr/bin/sudo <<\EOF
#! /bin/sh
# TODO: parse & pass-through sudo options from $@
sudo_options="-E"

for arg in "$@"
do
   case "$arg" in
    *\'*)
      arg=`echo "$arg" | sed "s/'/'\\\\\\\\''/g"` ;;
   esac
   cmd_options="$cmd_options '$arg'" 
done

exec /usr/bin/sudo $sudo_options scl enable devtoolset-1.1 "$cmd_options"
EOF
chmod 0755 %{buildroot}/%{_scl_root}/usr/bin/sudo
%scl_install
find %{buildroot}%{_scl_root} -type d | xargs chmod 755
mkdir -p %{buildroot}%{_sysconfdir}/alternatives
mkdir -p %{buildroot}%{_scl_root}/var/lib/alternatives
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_prefix}/lib
mkdir -p %{buildroot}%{_prefix}/lib64
mkdir -p %{buildroot}%{_libexecdir}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_infodir}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_datadir}/locale
mkdir -p %{buildroot}%{_docdir}

%files

%files runtime
%defattr(-,root,root,-)
%scl_files
%{_scl_root}/usr/bin/sudo

%files build
%{_root_sysconfdir}/rpm/macros.%{scl}-config

%changelog
* Fri Jan 04 2013 Matt Newsome <mnewsome@redhat.com> 1-13
* bz891991: remove dependency on pcp

* Tue Oct 23 2012 Frank Ch. Eigler <fche@redhat.com> 1-12
* bz849452: improve sudo wrapper with better args quoting, stdin passthrough

* Mon Oct 15 2012 Marek Polacek <polacek@redhat.com> 1-11
- bz862740: require also pcp-scl-initscripts package

* Thu Sep 13 2012 Marek Polacek <polacek@redhat.com> 1-10
- provide Obsoletes also for devtoolset-1.1 package
- obsolete also devtoolset-1.0-gdb-doc and devtoolset-1.0-libstdc++-docs

* Wed Sep 12 2012 Marek Polacek <polacek@redhat.com> 1-9
- bz852152: fix up $MANPATH

* Fri Aug 24 2012 Frank Ch. Eigler <fche@redhat.com> 1-8
- tweak $PYTHONPATH -> %{scl_root}/usr/lib*/...

* Wed Aug 22 2012 Frank Ch. Eigler <fche@redhat.com> 1-7
- add $PYTHONPATH definition, roughly paralleling PERL5LIB

* Tue Aug 21 2012 Frank Ch. Eigler <fche@redhat.com> 1-6
- bz849452: include a %{_scl_root}/usr/bin/sudo wrapper.
- add %{_scl_root}/usr/lib/perl5 to PERL5LIB.

* Tue Aug 14 2012 Jakub Jelinek <jakub@redhat.com> 1-5
- make devtoolset-1.1 subpackage require also DTS 1.1
  gcc-gfortran, elfutils, pcp, valgrind, systemtap, oprofile
  and dwz

* Mon Aug 13 2012 Frank Ch. Eigler <fche@redhat.com> 1-4
- workaround for bz847911: LD_LIBRARY_PATH must grow

* Fri Jul 27 2012 Frank Ch. Eigler <fche@redhat.com> 1-3
- pcp related environment variables

* Thu Jul 19 2012 Jakub Jelinek <jakub@redhat.com> 1-2
- obsolete DTS 1.0 packages in devtoolset-1.1-runtime

* Fri Jun 22 2012 Jakub Jelinek <jakub@redhat.com> 1-1
- Initial package
